/*************************************************
* Hardware Timer Source File                     *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#include <botan/tm_hard.h>

namespace Botan {

/*************************************************
* Get the timestamp                              *
*************************************************/
u64bit Hardware_Timer::clock() const
   {
   u64bit rtc = 0;

#if defined(__GNUG__) && (defined(__i386__) || defined(__x86_64__))
   u32bit rtc_low = 0, rtc_high = 0;
   asm volatile("rdtsc" : "=d" (rtc_high), "=a" (rtc_low));
   rtc = ((u64bit)rtc_high << 32) | rtc_low;
#elif defined(__GNUG__) && defined(__alpha__)
   asm volatile("rpcc %0" : "=r" (rtc));
#elif defined(__GNUG__) && (defined(__sparc64__) || defined(__sparc_v9__))
   asm volatile("rd %%tick, %0" : "=r" (rtc));
#else
   #error Unsure how to access hardware timer on this system
#endif

   return rtc;
   }

}
