/*************************************************
* MP Dword Functions Source File                 *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#include <botan/mp_core.h>
#include <botan/mp_impl.h>

extern "C" {

/*************************************************
* Do a 2-word/1-word Division                    *
*************************************************/
word bigint_divop(word n1, word n0, word d)
   {
   return ((((dword)n1 << MP_WORD_BITS) | n0) / d);
   }

/*************************************************
* Do a 2-word/1-word Modulo                      *
*************************************************/
word bigint_modop(word n1, word n0, word d)
   {
   return ((((dword)n1 << MP_WORD_BITS) | n0) % d);
   }

}
